<!--
  ~ (c) Copyright 2024 Swiss Post Ltd.
  -->
<h1 class="h2 fw-medium mb-3">
	{{ 'manageSettings.title' | translate }}
</h1>
<p class="mb-4">
	{{ 'manageSettings.instruction' | translate }}
</p>

<div *ngIf="!startingSDM; else starting" class="alert alert-info page-actions">
	<i aria-hidden="true" class="bi bi-pen"></i>
	<p>
		{{ 'manageSettings.pageActions.instruction' | translate }}
	</p>
	<button (click)="previous()" class="btn btn-link" type="button">
		<i aria-hidden="true" class="bi bi-arrow-left-circle"></i>
		{{ 'common.previous' | translate }}
	</button>
	<button (click)="save()" [disabled]="!settingsForm.valid" class="btn btn-link" type="button">
		<i aria-hidden="true" class="bi bi-floppy"></i>
		{{ 'manageSettings.pageActions.save' | translate }}
	</button>
	<button (click)="delete()" [disabled]="settings?.id === -1" class="btn btn-link link-danger" type="button">
		<i aria-hidden="true" class="bi bi-trash"></i>
		{{ 'manageSettings.pageActions.delete' | translate }}
	</button>
	<button (click)="startSDM()" [disabled]="!settingsForm.valid" class="btn btn-primary" type="button">
		<i aria-hidden="true" class="bi bi-play-circle"></i>
		{{ 'manageSettings.pageActions.start' | translate }}
	</button>
</div>

<ng-template #starting>
	<div class="alert alert-primary page-actions">
		<div class="spinner">
			<span aria-hidden="true" class="spinner-border"></span>
			<span class="visually-hidden" role="status">{{ 'common.loading' | translate }}</span>
		</div>
		<p>
			{{ 'manageSettings.pageActions.starting' | translate }} [{{ settingsForm.value.electionEventSeed }}]
		</p>
	</div>
</ng-template>

<sdm-scrollbar>
	<form *ngIf="!startingSDM" [formGroup]="settingsForm">
		<div class="card mb-3">
			<div class="card-header">
				{{ 'manageSettings.properties.overallSection.title' | translate }}
			</div>
			<div class="card-body">
				<div class="mb-3">
					<p id="existingModes">{{ 'manageSettings.properties.overallSection.mode' | translate }}</p>
					<ng-container *ngIf="settings?.id !== -1; else selectMode">
						<p class="fs-5 mt-2 ms-3">{{mode.value}}</p>
						<input type="hidden" formControlName="mode" id="modeInput"/>
					</ng-container>
					<ng-template #selectMode>
						<ul aria-labelledby="existingModes" class="list-unstyled ps-3">
							<li *ngFor="let sdmMode of sdmModes" class="form-check d-flex align-items-center gap-2 my-3" data-test="mode">
								<input [value]="sdmMode"
									   class="form-check-input"
									   formControlName="mode"
									   id="mode--{{sdmMode}}"
									   type="radio">
								<label class="form-check-label fw-light fs-5" for="mode--{{sdmMode}}">
									{{ sdmMode }}
								</label>
							</li>
						</ul>
					</ng-template>
				</div>
				<div class="mb-3">
					<label class="form-label" for="electionEventSeedInput">
						{{ 'manageSettings.properties.overallSection.electionEventSeed.label' | translate }}
					</label>
					<input [dropSpecialCharacters]="false"
						   [inputTransformFn]="inputTransformFn"
						   [outputTransformFn]="outputTransformFn"
						   [specialCharacters]="['_']"
						   class="form-control form-control-lg"
						   formControlName="electionEventSeed"
						   id="electionEventSeedInput"
						   mask="UU_00000000_UU00"
						   type="text"/>
					<p class="mb-3 mt-3" id="electionEventSeedInstruction">
						{{ 'manageSettings.properties.overallSection.electionEventSeed.policy.instruction' | translate }}
					</p>
					<ul aria-labelledby="electionEventSeedInstruction" class="list-unstyled ms-3 d-flex flex-column gap-2 mb-4">
						<li *ngFor="let policy of electionEventSeedPolicies">
							<sdm-policy
									[isMet]="!electionEventSeedHasError(policy)"
									[label]="'manageSettings.properties.overallSection.electionEventSeed.policy.' + policy | translate">
							</sdm-policy>
						</li>
					</ul>
				</div>
				<ng-container *ngIf="mode.value === 'ONLINE'">
					<div class="mb-3">
						<label class="form-label"
							   for="onlineHostInput">{{ 'manageSettings.properties.overallSection.onlineHost' | translate }}</label>
						<input class="form-control form-control" formControlName="onlineHost" id="onlineHostInput" type="text"/>
					</div>
					<div class="mb-3">
						<label class="form-label"
							   for="twoWaySSLLocationInput">{{ 'manageSettings.properties.overallSection.twoWaySSLLocation' | translate }}</label>
						<input class="form-control form-control" formControlName="twoWaySSLLocation" id="twoWaySSLLocationInput" type="text"/>
					</div>
					<div class="mb-3">
						<label class="form-label"
							   for="twoWaySSLPwdLocationInput">{{ 'manageSettings.properties.overallSection.twoWaySSLPwdLocation' | translate }}</label>
						<input class="form-control form-control" formControlName="twoWaySSLPwdLocation" id="twoWaySSLPwdLocationInput" type="text"/>
					</div>
				</ng-container>
			</div>
		</div>

		<div class="card mb-3">
			<div class="card-header">
				{{ 'manageSettings.properties.dataSection.title' | translate }}
			</div>
			<div class="card-body">
				<div class="mb-3">
					<label class="form-label"
						   for="workspaceInput">{{ 'manageSettings.properties.dataSection.workspaceFolder' | translate }}</label>
					<input class="form-control form-control" formControlName="workspaceFolder" id="workspaceInput" type="text"/>
				</div>
				<div *ngIf="!workspaceValid" class="ms-3 mb-4">
					<i *ngIf="!workspaceValid" aria-hidden="true" class="ms-3 mb-4 bi me-2 text-danger bi-x-circle">
						{{ 'manageSettings.properties.dataSection.workspaceFolderError' | translate }}
					</i>
				</div>
				<div *ngIf="mode.value !== 'TALLY'" class="mb-3">
					<label class="form-label"
						   for="outputFolderInput">{{ 'manageSettings.properties.dataSection.outputFolder' | translate }}</label>
					<input class="form-control form-control" formControlName="outputFolder" id="outputFolderInput" type="text"/>
				</div>
				<div *ngIf="mode.value === 'SETUP'" class="mb-3">
					<label class="form-label"
						   for="externalConfigurationFolderInput">{{ 'manageSettings.properties.dataSection.externalConfigurationFolder' | translate }}</label>
					<input class="form-control form-control"
						   formControlName="externalConfigurationFolder"
						   id="externalConfigurationFolderInput"
						   type="text"/>
				</div>
				<div *ngIf="mode.value === 'SETUP'" class="mb-3">
					<label class="form-label" for="printFolderInput">{{ 'manageSettings.properties.dataSection.printFolder' | translate }}</label>
					<input class="form-control form-control" formControlName="printFolder" id="printFolderInput" type="text"/>
				</div>
				<div *ngIf="mode.value !== 'ONLINE'" class="mb-3">
					<label class="form-label"
						   for="verifierFolderInput">{{ 'manageSettings.properties.dataSection.verifierFolder' | translate }}</label>
					<input class="form-control form-control" formControlName="verifierFolder" id="verifierFolderInput" type="text"/>
				</div>
				<div class="mb-3">
					<label class="form-label" for="passwordInput"
						   id="passwordInstruction">{{ 'manageSettings.properties.dataSection.password' | translate }}</label>
					<div class="input-group">
						<input [type]="hidePassword ? 'password' : 'text'" class="form-control form-control" formControlName="password"
							   id="passwordInput"/>
						<button (click)="hidePassword = !hidePassword"
								class="btn btn-with-border password-button align-items-center d-flex"
								type="button">
							<i [ngClass]="{'bi bi-eye-slash': !hidePassword, 'bi bi-eye-fill': hidePassword}"
							   class="fa"></i>
						</button>
					</div>
					<ul aria-labelledby="passwordInstruction" class="list-unstyled ms-3 d-flex flex-column gap-2 mt-3 mb-4" id="passwordPolicies">
						<li *ngFor="let policy of passwordPolicies">
							<sdm-policy [attr.data-test]="'policy-' + policy"
										[isMet]="!!password.value && !passwordHasError(policy)"
										[label]="'passwords.creation.passwordPolicy.' + policy | translate"></sdm-policy>
						</li>
					</ul>
				</div>
			</div>
		</div>

		<div *ngIf="mode.value !== 'ONLINE'" class="card mb-3">
			<div class="card-header">
				{{ 'manageSettings.properties.directTrustSection.title' | translate }}
			</div>
			<div class="card-body">
				<div class="mb-3">
					<label class="form-label"
						   for="directTrustLocationInput">{{ 'manageSettings.properties.directTrustSection.directTrustLocation' | translate }}</label>
					<input class="form-control form-control" formControlName="directTrustLocation" id="directTrustLocationInput" type="text"/>
				</div>
				<div class="mb-3">
					<label class="form-label"
						   for="directTrustPwdLocationInput">{{ 'manageSettings.properties.directTrustSection.directTrustPwdLocation' | translate }}</label>
					<input class="form-control form-control" formControlName="directTrustPwdLocation" id="directTrustPwdLocationInput" type="text"/>
				</div>
			</div>
		</div>

		<div *ngIf="this.settingsForm.controls['mode'].value === 'SETUP'" class="card mb-3">
			<div class="card-header">
				{{ 'manageSettings.properties.chunksSection.title' | translate }}
			</div>
			<div class="card-body">
				<div class="mb-3">
					<label class="form-label"
						   for="choiceCodeGenerationChunkSizeInput">{{ 'manageSettings.properties.chunksSection.choiceCodeGenerationChunkSize' | translate }}</label>
					<select class="form-select" formControlName="choiceCodeGenerationChunkSize" id="choiceCodeGenerationChunkSizeInput">
						<option *ngFor="let chunkSize of chunkSizes"
								[ngValue]="chunkSize.value">{{ 'manageSettings.properties.chunksSection.' + chunkSize.label | translate }}
						</option>
					</select>
				</div>
			</div>
		</div>
	</form>
</sdm-scrollbar>
